#!/bin/bash

# *** What's Up What's Down Who's Around ***
# *** Version 1.0 - 15th October 2000    ***
# *** Written by Ross Walker             ***
# *** Copyright Ross Walker 2000	 ***
# *** All Rights Reserved                ***

#This script attempts to ping each machine listed in MACHINE-LIST
#It then writes a web page called wuwdwa.html that lists what machines
#responded and what didn't.

#NOTE - The file format for MACHINE LIST is:		MACHINENAME	IPADDRESS     no spaces in either 

#THE LINE BELOW MUST BE MODIFIED TO POINT TO THE WEB ACCESS DIRECTORY FOR WUWDWA.html
WUWDWAPATH="/home/httpd/html/wuwdwa"

rm -f wuwdwa.html

#We append the file wuwdwa_top.txt to our wuwdwa.html file
cat wuwdwa_top.txt >> wuwdwa.html

#Now we write the time and date to the wuwdwa.html temp file
echo -n $( date ) >> wuwdwa.html
echo "</p>" >> wuwdwa.html
echo "<div align=\"center\">" >> wuwdwa.html
echo "<table border=\"1\" cellspacing=\"0\" width=\"580\" bordercolor=\"#000000\" bordercolorlight=\"#000000\" bordercolordark=\"#000000\">" >> wuwdwa.html
echo "<tr>" >> wuwdwa.html
echo "<td align=\"center\" width=\"180\" valign=\"middle\"><b>Machine Name</b></td>" >> wuwdwa.html
echo "<td align=\"center\" width=\"160\" valign=\"middle\"><b>IP Address</b></td>" >> wuwdwa.html
echo "<td align=\"center\" width=\"80\" valign=\"middle\"><b>UP</b></td>" >> wuwdwa.html
echo "<td align=\"center\" width=\"80\" valign=\"middle\"><b>DOWN</b></td>" >> wuwdwa.html
echo "<td align=\"center\" width=\"80\" valign=\"middle\"><b>ERROR</b></td>">> wuwdwa.html
echo "</tr>" >> wuwdwa.html

#Now we loop through each machine in the MACHINE-LIST writing it to the web page

count=0
for MACHPING in $( cat MACHINE-LIST ); do
   let count=count+1
   if [ "$count" = "1" ]; then
        #MACHPING currently contains the machine name - not the ip address
	echo "<tr>" >> wuwdwa.html
	echo "<td align=\"center\" width=\"180\" height=\"21\" valign=\"middle\">$MACHPING</td>" >> wuwdwa.html		
   else
	if [ "$count" = "2" ]; then
		#EXIT CODES FROM PING 0 = good, 1 = Down, 2 = Error
		#MACHPING now contains the IP Address
		echo "<td align=\"center\" width=\"160\" height=\"31\" valign=\"middle\">$MACHPING</td>" >> wuwdwa.html
		ping -c 3 $MACHPING > /dev/null
		if [ $? = 0 ]; then
			#PING WAS SUCCESSFUL
			echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\"><img border=\"0\" src=\"images/up.gif\" width=\"78\" height=\"31\"></td>" >> wuwdwa.html
			echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\">&nbsp;</td>" >> wuwdwa.html
			echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\">&nbsp;</td>" >> wuwdwa.html
		else 	if [ $? = 1 ];  then
				#PING FAILED
				echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\">&nbsp;</td>" >> wuwdwa.html
				echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\"><img border=\"0\" src=\"images/down.gif\" width=\"78\" height=\"31\"></td>" >> wuwdwa.html
				echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\">&nbsp;</td>" >> wuwdwa.html
			else
				#PING FAILED
				echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\">&nbsp;</td>" >> wuwdwa.html
				echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\">&nbsp;</td>" >> wuwdwa.html
				echo "<td width=\"80\" align=\"center\" height=\"31\" valign=\"middle\"><img border=\"0\" src=\"images/failed.gif\" width=\"78\" height=\"31\"></td>" >> wuwdwa.html
			fi
		fi

		echo "</tr>" >> wuwdwa.html   
		#Reset the counter to zero
		let count=0
	 fi
   fi
done

#Now we put the bottom of the file on
cat wuwdwa_bottom.txt >> wuwdwa.html

#Now we copy the file over the live web one - NOTE THIS LINE NEEDS TO BE
#CHANGED TO MATCH YOUR SYSTEM SETUP.

cp -f wuwdwa.html $WUWDWAPATH/index.html

exit

